#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win102.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */
    INITCOMMONCONTROLSEX iCCE;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 102",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           330,                 /* Ancho */
           250,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    iCCE.dwSize = sizeof(INITCOMMONCONTROLSEX);
    iCCE.dwICC = ICC_BAR_CLASSES;
    InitCommonControlsEx(&iCCE);

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    static UINT NOTIFICACION;
    static int itemDrag;
    int itemPos;
    int i;
    char cad[64];
    DRAGLISTINFO *lpDLI;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(-14, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));
            CreateWindowEx(0, "LISTBOX", NULL,
                WS_CHILD | WS_VISIBLE | WS_TABSTOP | LBS_STANDARD,
                80,10,160,200,
                hwnd, (HMENU)ID_DRAGLISTBOX,
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "Listbox:", WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,10,220,20, hwnd, (HMENU)(ET_DRAGLISTBOX),
                hInstance, NULL);
            MakeDragList(GetDlgItem(hwnd, ID_DRAGLISTBOX));
            NOTIFICACION = RegisterWindowMessage(DRAGLISTMSGSTRING);
            itemDrag = -1;
            // Insertar items:
            for(i = 0; i < 20; i++) {
                sprintf(cad, "Cadena #%d", i);
                SendDlgItemMessage(hwnd, ID_DRAGLISTBOX, LB_INSERTSTRING, (WPARAM)i, (LPARAM)cad);
            }
            SendDlgItemMessage(hwnd, ID_DRAGLISTBOX, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ET_DRAGLISTBOX, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            break;
        case WM_DESTROY:
            DeleteObject(hFont);
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
            if(msg == NOTIFICACION) {
                //printf("%d\n", wParam);
                lpDLI = (DRAGLISTINFO*)lParam;
                if(lpDLI->hWnd == GetDlgItem(hwnd, ID_DRAGLISTBOX)) // wParam == ID_DRAGLISTBOX
                    switch(lpDLI->uNotification) {
                        case DL_BEGINDRAG:
                            itemDrag = LBItemFromPt(lpDLI->hWnd, lpDLI->ptCursor, FALSE);
                            return TRUE;
                        case DL_CANCELDRAG:
                            itemDrag = -1;
                            InvalidateRect(hwnd, 0, TRUE);
                            break;
                        case DL_DROPPED:
                            if(itemDrag != -1) {
                                itemPos = LBItemFromPt(lpDLI->hWnd, lpDLI->ptCursor, FALSE);
                                if(itemPos > itemDrag) itemPos--;
                                SendMessage(lpDLI->hWnd, LB_GETTEXT, (WPARAM)itemDrag, (LPARAM)cad);
                                SendMessage(lpDLI->hWnd, LB_DELETESTRING, (WPARAM)itemDrag, 0);
                                SendMessage(lpDLI->hWnd, LB_INSERTSTRING, (WPARAM)itemPos, (LPARAM)cad);
                                SendMessage(lpDLI->hWnd, LB_SETCURSEL, (WPARAM)itemPos, 0);
                                itemDrag = -1;
                                InvalidateRect(hwnd, 0, TRUE);
                            }
                            break;
                        case DL_DRAGGING:
                            if(itemDrag != -1) {
                                itemPos = LBItemFromPt(lpDLI->hWnd, lpDLI->ptCursor, TRUE);
                                DrawInsert(hwnd, lpDLI->hWnd, itemPos);
                                return DL_MOVECURSOR;
                            }
                            break;
                    }
            } else
                return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
